• Educational Codeforces Round 137 (Rated for Div. 2)练习笔记


    A. Password" role="presentation" style="position: relative;">A. Password

    Monocarp" role="presentation" style="position: relative;">Monocarp 的手机密码由 4" role="presentation" style="position: relative;">4 位数字组成(首位可以为 0" role="presentation" style="position: relative;">0 ),其中只包含两个不同的数字,并且这两个数字都出现了两次。现在他告诉你他的密码肯定不会包含哪些数字,让你求出有多少种可能的密码。多组数据。
    其实答案就是 (10n2)(42)" role="presentation" style="position: relative;">(10n2)(42)

    1. int T, n;
    2. int main(){
    3. T = rd();
    4. while(T--){
    5. n = rd();
    6. fp(i, 1, n)rd();
    7. printf("%d\n", (10-n)*(9-n)*3);
    8. }
    9. return 0;
    10. }

    B. Permutation Value" role="presentation" style="position: relative;">B. Permutation Value

    定义一个排列的价值为:有多少个区间,使得这个区间也是一个排列。给定一个 n(n50)" role="presentation" style="position: relative;">n(n50) ,要求输出任意一个价值最小的长度为 n" role="presentation" style="position: relative;">n 的排列。多组数据。
    如果一个区间也是排列,并且长度 >1" role="presentation" style="position: relative;">>1 ,那么它肯定包含 1,2" role="presentation" style="position: relative;">1,2 。所以只需要让 1" role="presentation" style="position: relative;">1 在最左边, 2" role="presentation" style="position: relative;">2 在最右边,就可以使这个排列的价值最小。

    1. int T, n;
    2. int main(){
    3. T = rd();
    4. while(T--){
    5. n = rd();
    6. printf("1 "); fp(i, 3, n)printf("%d ", i); printf("2\n");
    7. }
    8. return 0;
    9. }

    C. Save the Magazines" role="presentation" style="position: relative;">C. Save the Magazines

    从左到右排列了 n(n2×105)" role="presentation" style="position: relative;">n(n2×105) 个盒子,第 i" role="presentation" style="position: relative;">i 个盒子里有 ai" role="presentation" style="position: relative;">ai 本杂志。有的盒子上有一个盖子,有的则没有。一次操作为将某个盒子上的盖子移到左边的盒子上,每个盖子最多只能被移动一次。求若干次操作之后,最多有多少本杂志可以被盖子盖住。多组数据。
    很好想的做法是直接 dp" role="presentation" style="position: relative;">dp 。设 fi,0" role="presentation" style="position: relative;">fi,0 表示不移动第 i" role="presentation" style="position: relative;">i 个盒子上的盖子,第 1" role="presentation" style="position: relative;">1~i" role="presentation" style="position: relative;">i 个盒子最多可以有多少本杂志被盖住,设 fi,1" role="presentation" style="position: relative;">fi,1 表示移动第 i" role="presentation" style="position: relative;">i 个盒子上的盖子(如果有的话),第 1" role="presentation" style="position: relative;">1~i" role="presentation" style="position: relative;">i 个盒子最多可以有多少本杂志被盖住。
    如果第 i" role="presentation" style="position: relative;">i 个盒子一开始没有盖子,则 fi,0=max{fi1,0,fi1,1}" role="presentation" style="position: relative;">fi,0=max{fi1,0,fi1,1}
    否则, fi,0=max{fi1,0,fi1,1}+ai,fi,1=fi1,lidi1+ai1" role="presentation" style="position: relative;">fi,0=max{fi1,0,fi1,1}+ai,fi,1=fi1,lidi1+ai1 ,其中 lidi" role="presentation" style="position: relative;">lidi 表示第 i" role="presentation" style="position: relative;">i 个盒子上一开始有没有盖子。

    1. cint maxn = 200010;
    2. int T, n, lid[maxn], a[maxn];
    3. unsigned int f[maxn][2];
    4. int main(){
    5. T = rd();
    6. while(T--){
    7. n = rd();
    8. fp(i, 1, n)scanf("%1d", &lid[i]);
    9. fp(i, 1, n)a[i] = rd(), f[i][0] = f[i][1] = 0;
    10. if(lid[1])f[1][0] = a[1];
    11. fp(i, 2, n){
    12. if(!lid[i])f[i][0] = max(f[i-1][0], f[i-1][1]);
    13. else{
    14. f[i][0] = max(f[i-1][0], f[i-1][1])+a[i];
    15. f[i][1] = (lid[i-1] ? f[i-1][1] : f[i-1][0]) + a[i-1];
    16. }
    17. }
    18. printf("%u\n", max(f[n][0], f[n][1]));
    19. }
    20. return 0;
    21. }

    D. Problem with Random Tests" role="presentation" style="position: relative;">D. Problem with Random Tests

    给定一个长度为 n(n106)" role="presentation" style="position: relative;">n(n106)01" role="presentation" style="position: relative;">01 串,要求截取任意两段(可以相交),使得这两段或运算结果最大。数据随机
    或运算具有贪心的性质,所以让第一段取到最左边的 1" role="presentation" style="position: relative;">101" role="presentation" style="position: relative;">01 串的右端点显然是最优的。
    然后考虑一种暴力,枚举第二段的左端点,然后暴力算,复杂度是 O(n2)" role="presentation" style="position: relative;">O(n2) 的。
    考虑第一个优化,首先最优的方法肯定是选取与第一个 1" role="presentation" style="position: relative;">1 在同一块(全是 1" role="presentation" style="position: relative;">1 的一段)里的 1" role="presentation" style="position: relative;">1 作为第二段的左端点,因为这样才可能通过调整右端点的位置让这个 1" role="presentation" style="position: relative;">1 与第一段的第一个 0" role="presentation" style="position: relative;">0 进行或运算。
    这样只是常数上进行了优化。再考虑第二个优化,怎么使用随机数据这个条件?
    我们将使用第一个优化过后所有的 1" role="presentation" style="position: relative;">1 作为备选项,并将它们与第一段的第一个 0" role="presentation" style="position: relative;">0 对齐。然后从左到右枚举第一段里的所有 0" role="presentation" style="position: relative;">0 ,看每个备选的第二段能否在对应的位置上是 1" role="presentation" style="position: relative;">1 。如果有至少一个备选项满足条件,则将所有不满足条件的备选项去掉;否则全部保留,继续往后枚举第一段的 0" role="presentation" style="position: relative;">0 。最后剩下的就是最优的第二段。
    因为数据随机,所以每次都期望去掉一半的备选项,所以这样做的复杂度是 O(nlogn)" role="presentation" style="position: relative;">O(nlogn) 的。

    1. cint maxn = 1000010;
    2. int n, a[maxn], pos[maxn], cnt, f[maxn], tot;
    3. int main(){
    4. n = rd();
    5. fp(i, 1, n)scanf("%1d", &a[i]);
    6. int now = 0; fp(i, 1, n)if(a[i]){ now = i; break; }
    7. if(!now)return putchar('0'), 0;
    8. fp(i, now+1, n)if(!a[i])pos[++cnt] = i;
    9. fp(i, 1, pos[1]-1)if(a[i])f[++tot] = i;
    10. fp(i, 1, cnt){
    11. int fl = 0, _tot = 0;
    12. fp(j, 1, tot)if(f[j] + pos[i]-pos[1] <= n && a[f[j] + pos[i]-pos[1]]){ fl = 1; break; }
    13. if(!fl)continue;
    14. fp(j, 1, tot)if(f[j] + pos[i]-pos[1] <= n && a[f[j] + pos[i]-pos[1]])f[++_tot] = f[j];
    15. tot = _tot;
    16. }
    17. int tmp = 0;
    18. fp(i, now, n){
    19. if(a[i])putchar('1');
    20. else{
    21. ++tmp;
    22. putchar(a[f[1]+pos[tmp]-pos[1]] ? '1' : '0');
    23. }
    24. }
    25. return 0;
    26. }

    E. FTL" role="presentation" style="position: relative;">E. FTL

    有两门激光炮,各自有一个威力 d1,d2(di5000)" role="presentation" style="position: relative;">d1,d2(di5000) 和充能时间 p1,p2(pi1012)" role="presentation" style="position: relative;">p1,p2(pi1012) 。敌人拥有 h(h5000)" role="presentation" style="position: relative;">h(h5000) 滴血和 s(smin{d1,d2})" role="presentation" style="position: relative;">s(smin{d1,d2}) 点防御,每次在某一门激光炮充能完毕后使用它,也可以等两门激光炮都充能后一起发射,造成的伤害为:这次使用的激光炮的威力(或威力之和)s" role="presentation" style="position: relative;">s 。求出最少需要多少时间可以击杀敌人。
    由于两门炮分别充能,所以贪心是不好做的……
    考虑 dp" role="presentation" style="position: relative;">dp 。设 dpi" role="presentation" style="position: relative;">dpi 代表造成 i" role="presentation" style="position: relative;">i 点伤害最少需要多长时间。我们可以钦定最后一次攻击为两门炮一起攻击,因为如果不是一起攻击的,我们可以让较早发射的炮等到另一门炮充能完毕过后一起发射,而且这样造成的伤害更高。那我们可以枚举第一门炮单独发射多少次过后进行一次两门炮齐射,再枚举第二门炮单独发射多少次过后进行两门炮齐射。复杂度大概就是 O(h^2)" role="presentation" style="position: relative;">O(h^2) 的。

    1. cint maxn = 5010;
    2. int p1, p2, h, s;
    3. LL t1, t2, f[maxn];
    4. int main(){
    5. scanf("%d %lld", &p1, &t1);
    6. scanf("%d %lld", &p2, &t2);
    7. scanf("%d %d", &h, &s);
    8. memset(f, 0x3f, sizeof f), f[0] = 0;
    9. fp(i, 0, h){
    10. f[min(h, i+p1-s)] = min(f[min(h, i+p1-s)], f[i]+t1);
    11. f[min(h, i+p2-s)] = min(f[min(h, i+p2-s)], f[i]+t2);
    12. fp(j, 1, h){
    13. if(j*t1 >= t2){
    14. LL dam = 1ll*(j-1)*(p1-s) + (j*t1-t2)/t2*(p2-s) + p1+p2-s;
    15. f[min((LL)h, i+dam)] = min(f[min((LL)h, i+dam)], f[i]+j*t1);
    16. }
    17. if(j*t2 >= t1){
    18. LL dam = 1ll*(j-1)*(p2-s) + (j*t2-t1)/t1*(p1-s) + p1+p2-s;
    19. f[min((LL)h, i+dam)] = min(f[min((LL)h, i+dam)], f[i]+j*t2);
    20. }
    21. }
    22. }
    23. printf("%lld\n", f[h]);
    24. return 0;
    25. }

    F. Intersection and Union" role="presentation" style="position: relative;">F. Intersection and Union

    给定 n(n3×105)" role="presentation" style="position: relative;">n(n3×105) 个区间 [li,ri](li,ri3×105)" role="presentation" style="position: relative;">[li,ri](li,ri3×105) 。区间之间的操作有三种, ,," role="presentation" style="position: relative;">,, ,分别表示交、并、对称差(并集减去交集)。记第 i" role="presentation" style="position: relative;">i 个区间为 Si" role="presentation" style="position: relative;">Si ,定义一个操作序列 {op1,op2,...,opn1}" role="presentation" style="position: relative;">{op1,op2,...,opn1} 的价值为 |(((S1op1S2)op2S3)op3S4)...opn1Sn|" role="presentation" style="position: relative;">|(((S1op1S2)op2S3)op3S4)...opn1Sn| 。求出所有操作序列的价值之和,对 998244353" role="presentation" style="position: relative;">998244353 取模。
    考虑单独算每个位置对答案的贡献,即计算有多少种操作序列能使它留在最后的集合里。对于位置 x" role="presentation" style="position: relative;">x ,设 fi,0" role="presentation" style="position: relative;">fi,0 表示进行了第 i1" role="presentation" style="position: relative;">i1 次操作后,x" role="presentation" style="position: relative;">x 不在当前集合里的方案数; fi,1" role="presentation" style="position: relative;">fi,1 表示在当前集合里的方案数。
    如果 x[li,ri]" role="presentation" style="position: relative;">x[li,ri] ,分别考虑三种操作,那么有 fi,0=fi1,0+fi1,1,fi,1=(fi1,0+fi1,1)+fi1,1+fi1,0" role="presentation" style="position: relative;">fi,0=fi1,0+fi1,1,fi,1=(fi1,0+fi1,1)+fi1,1+fi1,0
    如果 x[li,ri]" role="presentation" style="position: relative;">x[li,ri] ,那么有fi,0=fi1,0+(fi1,0+fi1,1)+fi1,0,fi,1=fi1,1+fi1,1" role="presentation" style="position: relative;">fi,0=fi1,0+(fi1,0+fi1,1)+fi1,0,fi,1=fi1,1+fi1,1
    那么直接这样暴力算就是 O(n2)" role="presentation" style="position: relative;">O(n2) 的。
    可以发现当 x[li,ri]" role="presentation" style="position: relative;">x[li,ri][fi,0,fi,1]=[fi1,0,fi1,1]×[1212]" role="presentation" style="position: relative;">[fi,0,fi,1]=[fi1,0,fi1,1]×[1212]
    x[li,ri]" role="presentation" style="position: relative;">x[li,ri] 时有 [fi,0,fi,1]=[fi1,0,fi1,1]×[3012]" role="presentation" style="position: relative;">[fi,0,fi,1]=[fi1,0,fi1,1]×[3012]
    所以我们可以把所有区间的端点进行排序,并且从左到右枚举 x" role="presentation" style="position: relative;">x ,如果 x=li" role="presentation" style="position: relative;">x=li 或者 x=ri+1" role="presentation" style="position: relative;">x=ri+1,则更新第 i" role="presentation" style="position: relative;">i 个区间的转移矩阵,用线段树维护一个全局积,即可做到 O(nlogn)" role="presentation" style="position: relative;">O(nlogn)

    1. cint maxn = 300010, mod = 998244353;
    2. int n, l[maxn], r[maxn], L, R, f[maxn][2], ans;
    3. int p1[maxn], p2[maxn];
    4. il bool cmp1(cint &x, cint &y){ return l[x] < l[y]; }
    5. il bool cmp2(cint &x, cint &y){ return r[x] < r[y]; }
    6. struct matrix{ int a[3][3]; }t[maxn<<2], m1, m2;
    7. il matrix operator * (cn matrix &x, cn matrix &y){
    8. matrix ans;
    9. ans.a[1][1] = (1ll*x.a[1][1]*y.a[1][1] + 1ll*x.a[1][2]*y.a[2][1])%mod;
    10. ans.a[1][2] = (1ll*x.a[1][1]*y.a[1][2] + 1ll*x.a[1][2]*y.a[2][2])%mod;
    11. ans.a[2][1] = (1ll*x.a[2][1]*y.a[1][1] + 1ll*x.a[2][2]*y.a[2][1])%mod;
    12. ans.a[2][2] = (1ll*x.a[2][1]*y.a[1][2] + 1ll*x.a[2][2]*y.a[2][2])%mod;
    13. return ans;
    14. }
    15. void build(int d, int l, int r){
    16. if(l == r)return t[d] = m2, void();
    17. int md = l+r>>1;
    18. build(d<<1, l, md), build(d<<1|1, md+1, r);
    19. t[d] = t[d<<1]*t[d<<1|1];
    20. }
    21. void mdf(int d, int l, int r, cint &des, cn matrix &m){
    22. if(des == 1)return;
    23. if(l == r)return t[d] = m, void();
    24. int md = l+r>>1;
    25. if(des <= md)mdf(d<<1, l, md, des, m);
    26. else mdf(d<<1|1, md+1, r, des, m);
    27. t[d] = t[d<<1]*t[d<<1|1];
    28. }
    29. int main(){
    30. n = rd(), L = 3e5;
    31. fp(i, 1, n)l[i] = rd(), r[i] = rd();
    32. fp(i, 1, n)if(l[i] < L)L = l[i];
    33. fp(i, 1, n)if(r[i] > R)R = r[i];
    34. fp(i, 1, n)p1[i] = p2[i] = i;
    35. sort(p1+1, p1+1+n, cmp1), sort(p2+1, p2+1+n, cmp2);
    36. m1.a[1][1] = m1.a[2][1] = 1, m1.a[1][2] = m1.a[2][2] = 2;
    37. m2.a[1][1] = 3, m2.a[1][2] = 0, m2.a[2][1] = 1, m2.a[2][2] = 2;
    38. build(1, 2, n);
    39. int now1 = 0, now2 = 0;
    40. fp(i, L, R){
    41. while(now1 < n && l[p1[now1+1]] == i)++now1, mdf(1, 2, n, p1[now1], m1);
    42. while(now2 < n && r[p2[now2+1]] == i-1)++now2, mdf(1, 2, n, p2[now2], m2);
    43. if(l[1] <= i && i <= r[1])ans = (ans + t[1].a[2][2])%mod;
    44. else ans = (ans + t[1].a[1][2])%mod;
    45. }
    46. printf("%d\n", ans);
    47. return 0;
    48. }

    G. Antifibonacci Cut" role="presentation" style="position: relative;">G. Antifibonacci Cut

    定义 01" role="presentation" style="position: relative;">01f" role="presentation" style="position: relative;">f斐波那契串,其中 f1=0,f2=1,fn=fn1+fn2" role="presentation" style="position: relative;">f1=0,f2=1,fn=fn1+fn2 ,其中 +" role="presentation" style="position: relative;">+ 代表拼接。再定义 g(s)" role="presentation" style="position: relative;">g(s) 表示把 s" role="presentation" style="position: relative;">s 分割成若干个子串,并且没有任何子串是斐波那契串的方案数。现给出 n(n3000)" role="presentation" style="position: relative;">n(n3000)01" role="presentation" style="position: relative;">01s1,s2,...,sn" role="presentation" style="position: relative;">s1,s2,...,sn ( |si|1000" role="presentation" style="position: relative;">|si|1000 ),要求对于每个 i" role="presentation" style="position: relative;">i ,计算 g(s1+s2+...+si)(mod998244353)" role="presentation" style="position: relative;">g(s1+s2+...+si)(mod998244353)内存限制为 4M" role="presentation" style="position: relative;">4M
    首先可以做的事情是把所有串都拼起来,然后考虑怎么 dp" role="presentation" style="position: relative;">dp
    一种比较暴力的 dp" role="presentation" style="position: relative;">dp 为,设 dpi" role="presentation" style="position: relative;">dpi 表示 g(s[1...i])" role="presentation" style="position: relative;">g(s[1...i]) 。若没有非斐波那契串的限制,那么 dpi=j=1i1dpj" role="presentation" style="position: relative;">dpi=j=1i1dpj 。可以发现的一条性质为, fi2" role="presentation" style="position: relative;">fi2fi" role="presentation" style="position: relative;">fi 的后缀,并且 f33" role="presentation" style="position: relative;">f33 的长度会大于 3×106" role="presentation" style="position: relative;">3×106 。所以我们可以用 exKMP" role="presentation" style="position: relative;">exKMP 求出 s[1...i]" role="presentation" style="position: relative;">s[1...i] 分别与 f32,f31" role="presentation" style="position: relative;">f32,f31LCS" role="presentation" style="position: relative;">LCS 。以 f32" role="presentation" style="position: relative;">f32 为例,假设它的 LCS" role="presentation" style="position: relative;">LCS 对应的是 fk" role="presentation" style="position: relative;">fk ,那么令 dpi" role="presentation" style="position: relative;">dpi-=j=1kdpi|fj|" role="presentation" style="position: relative;">j=1kdpi|fj| 即可。复杂度是 O((si)log)" role="presentation" style="position: relative;">O((si)log)
    然而内存限制使得这题连 106" role="presentation" style="position: relative;">106 的数组都开不下……
    可以发现另外一些性质(默认不考虑 f1" role="presentation" style="position: relative;">f1 ): fi1" role="presentation" style="position: relative;">fi1fi" role="presentation" style="position: relative;">fi 的前缀;任何一个斐波那契串的前缀都可以表示成若干个编号不连续的斐波那契串拼接而成的形式。
    下证第二条性质:首先长度为 1" role="presentation" style="position: relative;">1 的前缀就是 f2=1" role="presentation" style="position: relative;">f2=1 ,长度为 2" role="presentation" style="position: relative;">2 的前缀就是 f3=10" role="presentation" style="position: relative;">f3=10 。假设长度为 1" role="presentation" style="position: relative;">1~n1" role="presentation" style="position: relative;">n1 的前缀都满足这个性质,设 fk" role="presentation" style="position: relative;">fk 为最长的长度小于等于 n" role="presentation" style="position: relative;">n 的斐波那契串。若 |fk|=n" role="presentation" style="position: relative;">|fk|=n ,那么长度为 n" role="presentation" style="position: relative;">n 时就成立。否则,由于 s[fk+1...n]" role="presentation" style="position: relative;">s[fk+1...n] 必然是 fk1" role="presentation" style="position: relative;">fk1 的前缀,且长度必然小于 |fk1|" role="presentation" style="position: relative;">|fk1| ,所以能表示成若干个编号不连续的斐波那契串的拼接,且编号最大的串编号不超过 k2" role="presentation" style="position: relative;">k2
    为了求出斐波那契串长度为 n" role="presentation" style="position: relative;">n 的前缀由哪些斐波那契串拼接而成,可以参考下面的代码:

    fb(i, 32, 1)if(n > fib[i])n -= fib[i];

    有了这些性质之后,假设现在计算了 dpi1" role="presentation" style="position: relative;">dpi1 ,我们可以维护 s[1...i1]" role="presentation" style="position: relative;">s[1...i1] 有哪些长度的斐波那契串前缀的后缀,于是得到若干个二元组: (l,dpil)" role="presentation" style="position: relative;">(l,dpil) 。考虑计算 dpi" role="presentation" style="position: relative;">dpi 时怎么维护这些二元组。首先,如果 si=1" role="presentation" style="position: relative;">si=1 ,此时就会得到一个新的二元组 (1,dpi1)" role="presentation" style="position: relative;">(1,dpi1) 。枚举旧的二元组,假设枚举到 (l,v)" role="presentation" style="position: relative;">(l,v) ,讨论长度为 l" role="presentation" style="position: relative;">l 的斐波那契串前缀是否能拓展 si" role="presentation" style="position: relative;">si 这一位。利用第二条性质,我们可以得出一个长度为 l+1" role="presentation" style="position: relative;">l+1 的斐波那契串前缀最后拼接的斐波那契串是否为 1" role="presentation" style="position: relative;">1 。如果是的话,那么 si" role="presentation" style="position: relative;">si 就必须为 1" role="presentation" style="position: relative;">1 ,否则必须为 0" role="presentation" style="position: relative;">0 。如果可以拓展这一位,那么检查 l+1" role="presentation" style="position: relative;">l+1 是否为斐波那契数,如果是,那么就让 dpi" role="presentation" style="position: relative;">dpi-=v" role="presentation" style="position: relative;">v ( dpi" role="presentation" style="position: relative;">dpi 初始为 j=1i1dpj" role="presentation" style="position: relative;">j=1i1dpj )。那么复杂度是小于 O(32i=1n|si|)" role="presentation" style="position: relative;">O(32i=1n|si|) 的。

    1. cint maxn = 1010, mod = 998244353;
    2. int n, len, fib[33], l[33], f[33], nl[33], nf[33], tot, ans = 1, sum = 1;
    3. char s[maxn];
    4. map<int, int> vis;
    5. il int getnxt(int len){
    6. fb(i, 32, 2)if(len > fib[i])len -= fib[i];
    7. return len == 1;
    8. }
    9. il void calc(int c){
    10. int nans = (sum-ans+mod)%mod, ntot = 0;
    11. if(c)ntot = 1, nl[ntot] = 1, nf[ntot] = ans;
    12. fp(i, 1, tot){
    13. if(c != getnxt(l[i]+1))continue;
    14. if(vis.count(l[i]+1))nans = (nans-f[i]+mod)%mod;
    15. nl[++ntot] = l[i]+1, nf[ntot] = f[i];
    16. }
    17. ans = nans, sum = (sum+ans)%mod, tot = ntot;
    18. fp(i, 1, tot)f[i] = nf[i], l[i] = nl[i];
    19. }
    20. int main(){
    21. fib[0] = fib[1] =1, vis[1] = 1;
    22. fp(i, 2, 32)fib[i] = fib[i-1]+fib[i-2], vis[fib[i]] = 1;
    23. scanf("%d", &n);
    24. while(n--){
    25. scanf("%s", s+1), len = strlen(s+1);
    26. fp(i, 1, len)calc(s[i]-'0');
    27. printf("%d\n", ans);
    28. }
    29. return 0;
    30. }
  • 相关阅读:
    yocto machine class解析之st-partitions-image
    d3.js 的使用
    一次POST调用,响应结果乱码问题排查(2)
    每日一个设计模式之【代理模式】
    TCP 通信流程详解(附有案例代码)
    武汉新时标文化传媒有限公司短视频运营方案
    C++(四)
    Matlab如何选择读取dat格式数据?
    动态规划算法(1)--矩阵连乘和凸多边形剖分
    知识付费直播间即时通讯
  • 原文地址:https://blog.csdn.net/P2718756941/article/details/127415871